{{/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */}}

{{/* ---- Includes ---- */}}
{{Include "cpp_common.tmpl"}}

{{/* ---- Overrides ---- */}}
{{Global "C++.EnumTypeOverride" "uint32_t"}}

{{$filename := print (Global "API") "_types.h" }}
{{$ | Macro "Types" | Format (Global "clang-format") | Write $filename}}

{{define "Types"}}
  {{AssertType $ "API"}}
  {{Template "C++.AOSP.Copyright"}}
  {{$guard := print "GAPII_" (Upper (Global "API")) "_TYPES_H"}}
¶
  #ifndef {{$guard}}
  #define {{$guard}}
¶
  #include "slice.h"
¶
  #include <memory>
  #include <string>
  #include <unordered_map>
  #include <vector>
¶
  #include <stdint.h>
  #include <string.h>
¶
  namespace gapii {«
¶
  {{range $e := $.Enums}}
    {{Template "DeclareType" $e}}
  {{end}}
  {{range $p := $.Pseudonyms}}
    {{Template "DeclareType" $p}}
  {{end}}
  {{range $m := $.Maps}}
    {{Template "DeclareType" $m}}
  {{end}}
  {{range $c := $.Classes}}
    {{Template "DeclareType" $c}}
  {{end}}
¶
  »} // namespace gapii
¶
  #endif // {{$guard}}
¶
{{end}}


{{/*
-------------------------------------------------------------------------------
  Emits the C++ type declaration specified AST type if it hasn't already been
  declared.
-------------------------------------------------------------------------------
*/}}
{{define "DeclareType"}}
  {{if not (IsBuiltin $)}}
    {{$key  := printf "ApiType%vDeclared" $.Name}}
    {{if not (Global $key)}}
      {{Global $key "true"}}
      {{     if IsClass       $}}{{Template "DeclareClass"     $}}
      {{else if IsEnum        $}}{{Template "DeclareEnum"      $}}
      {{else if IsMap         $}}{{Template "DeclareMap"       $}}
      {{else if IsPseudonym   $}}{{Template "DeclarePseudonym" $}}
      {{else if IsPointer     $}}{{Template "DeclareType"      $.To}}
      {{else if IsReference   $}}{{Template "DeclareType"      $.To}}
      {{else if IsStaticArray $}}{{Template "DeclareType"      $.ValueType}}
      {{else if IsSlice       $}}
      {{else}}{{Error "DeclareType does not support type '%T'" $}}
      {{end}}
¶
    {{end}}
  {{end}}
{{end}}


{{/*
-------------------------------------------------------------------------------
  Emits the declarations for all non-declared field types of the class followed
  by the class declaration.
-------------------------------------------------------------------------------
*/}}
{{define "DeclareClass"}}
  {{AssertType $ "Class"}}

  {{range $f := $.Fields}}
    {{Template "DeclareType" (TypeOf $f)}}
  {{end}}

  struct {{Template "C++.Type" $}} {
    {{range $f := $.Fields}}
      inline {{Template "C++.Type" $}}& Set{{$f.Name}}({{Template "C++.Type" $f}} v{{Template "C++.StaticArraySuffix" $f}}) {
      {{if IsStaticArray $f.Type}}
        {{$sa := Unpack $f.Type}}
        memcpy(m{{$f.Name}}, v, sizeof({{Template "C++.Type" $f}}) * {{$sa.Size}});
      {{else}}
        m{{$f.Name}} = v;
      {{end}}
        return *this;
      }
    {{end}}
¶
    {{range $f := $.Fields}}
      {{Template "C++.Type" $f}} m{{$f.Name}}{{Template "C++.StaticArraySuffix" $f}};
    {{end}}
  };
{{end}}


{{/*
-------------------------------------------------------------------------------
  Emits enum entry declarations as a number of uint32_t constants.
-------------------------------------------------------------------------------
*/}}
{{define "DeclareEnumEntries"}}
  {{AssertType $ "Enum"}}

  {{range $entry := $.Entries}}
  static const uint32_t {{Template "C++.EnumEntryName" $entry}} = {{$entry.Value}};
  {{end}}
  {{range $p := $.Extends}}{{Template "DeclareEnumEntries" $p}}{{end}}
{{end}}


{{/*
-------------------------------------------------------------------------------
  Emits an enum declaration as a number of uint32_t constants in a namespace.
-------------------------------------------------------------------------------
*/}}
{{define "DeclareEnum"}}
  {{AssertType $ "Enum"}}

  namespace {{Template "C++.EnumName" $}} {
    {{Template "DeclareEnumEntries" $}}
  }
{{end}}


{{/*
-------------------------------------------------------------------------------
  Emits the declaration of the pseudonym's target type (if it is not already
  declared) followed by the pseudonym's typedef declaration.
-------------------------------------------------------------------------------
*/}}
{{define "DeclarePseudonym"}}
  {{AssertType $ "Pseudonym"}}

  {{Template "DeclareType" $.To}}

  typedef {{Template "C++.Type" $.To}} {{Template "C++.Type" $}}{{Template "C++.StaticArraySuffix" $.To}};
{{end}}


{{/*
-------------------------------------------------------------------------------
  Emits the declaration of the map's key and value types (if it is not already
  declared) followed by the map's declaration as a std::unordered_map.
-------------------------------------------------------------------------------
*/}}
{{define "DeclareMap"}}
  {{AssertType $ "Map"}}

  {{Template "DeclareType" $.KeyType}}
  {{Template "DeclareType" $.ValueType}}

  typedef std::unordered_map<{{Template "C++.Type" $.KeyType}}, {{Template "C++.Type" $.ValueType}}> {{Template "C++.Type" $}};
{{end}}
